package com.api.messageCenter;

package ..deTemp.1743992397012;

import cn.hutool.core.codec.Base64Encoder;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ServiceUtil;
import com.engine.msgcenter.service.impl.MsgHomepageServiceImpl;
import com.engine.msgcenter.util.Util_Account;
import com.google.common.collect.Lists;
import com.weaver.general.Util;
import com.weavernorth.timing.util.PushUtil;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import weaver.conn.RecordSet;
import weaver.hrm.User;

@Path("/messageCenter")
public class MessageCenter {
  private Logger logger = LoggerFactory.getLogger(com.api.messageCenter.MessageCenter.class);
  
  private static final String bootUrl = "/e10PortalHomePage/api/weavernorth/portal/messageCenter/getProcessPage";
  
  public static final String queryUrl = "/emp-office-server/emp/external/unifiedMessage/batchMessageInfo";
  
  @POST
  @Path("/pushReadMsg")
  @Produces({"application/json"})
  public String pushReadMsg(@Context HttpServletRequest request, @Context HttpServletResponse response) {
    JSONObject resultObject = new JSONObject();
    resultObject.put("success", Boolean.valueOf(false));
    resultObject.put("code", Integer.valueOf(202));
    int pageSize = 1000;
    JSONArray msgList = new JSONArray();
    try {
      String userId = Util.null2String(request.getParameter("userId"));
      this.logger.info("pushReadMsg------->消息中心已读推送---->userId:{}", userId);
      String msgTypeId = Util.null2String(request.getParameter("msgTypeId"));
      this.logger.info("pushReadMsg------->消息中心已读推送---->msgTypeId:{}", msgTypeId);
      String msgId = Util.null2String(request.getParameter("msgId"));
      this.logger.info("pushReadMsg------->消息中心已读推送---->msgId:{}", msgId);
      String type = Util.null2String(request.getParameter("type"));
      this.logger.info("pushReadMsg------->消息中心已读推送---->type:{}", type);
      if (!"".equals(msgId))
        msgList = (msgId.indexOf(",") > -1) ? getMsgInfo(msgId, "0", userId, type) : getMsgInfo(msgId, "1", userId, type); 
      if (!"".equals(msgTypeId))
        msgList = getMsgInfo(msgTypeId, "2", userId, type); 
      if (msgList.size() <= pageSize && msgList.size() > 0) {
        postMessage(msgList);
      } else {
        List<List<Object>> partition = Lists.partition((List)msgList, pageSize);
        for (List<Object> objects : partition) {
          JSONArray jsonArray = JSONArray.parseArray(JSON.toJSONString(objects));
          postMessage(jsonArray);
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
      resultObject.put("message", e.getMessage());
      return resultObject.toJSONString();
    } 
    resultObject.put("success", Boolean.valueOf(true));
    resultObject.put("code", Integer.valueOf(200));
    resultObject.put("message", "成功");
    return resultObject.toJSONString();
  }
  
  private void postMessage(JSONArray msgList) {
    PushUtil pushUtil = new PushUtil();
    String clientType = "0";
    Map<String, Object> txEntity = new HashMap<>();
    txEntity.put("clientSecret", pushUtil.clientSecret);
    txEntity.put("clientType", clientType);
    txEntity.put("dataStatus", "02");
    txEntity.put("messageInfoList", msgList);
    this.logger.info("pushReadMsg------->消息中心已读推送---->msgList:{}", msgList);
    Map<String, Object> result = pushUtil.senPost(txEntity, "/emp-office-server/emp/external/unifiedMessage/batchMessageInfo");
    for (Map.Entry<String, Object> stringObjectEntry : result.entrySet())
      this.logger.info("pushReadMsg---------->result--->key:{}--->value:{}", stringObjectEntry.getKey(), stringObjectEntry.getValue()); 
  }
  
  @POST
  @Path("/getMsgTypeById")
  @Produces({"application/json"})
  public String getMsgTypeById(@Context HttpServletRequest request, @Context HttpServletResponse response) {
    JSONObject resultObject = new JSONObject();
    resultObject.put("success", Boolean.valueOf(false));
    resultObject.put("code", Integer.valueOf(202));
    String userId = request.getParameter("userId");
    User user = new User(Integer.valueOf(userId).intValue());
    if ("".equals(userId)) {
      resultObject.put("message", "用户ID为空，请检查后重试");
      return resultObject.toJSONString();
    } 
    Map<String, Object> paramMap = new HashMap<>();
    Map<String, Object> msgTypeNumberList = ((MsgHomepageServiceImpl)ServiceUtil.getService(MsgHomepageServiceImpl.class)).getMsgTypeNumberList(paramMap, user);
    resultObject.put("data", msgTypeNumberList.get("item"));
    resultObject.put("success", Boolean.valueOf(true));
    resultObject.put("code", Integer.valueOf(200));
    return resultObject.toJSONString();
  }
  
  @POST
  @Path("/setMsgRead")
  @Produces({"application/json"})
  public String setMsgRead(@Context HttpServletRequest request, @Context HttpServletResponse response) {
    JSONObject resultObject = new JSONObject();
    resultObject.put("success", Boolean.valueOf(false));
    resultObject.put("code", Integer.valueOf(202));
    String messageId = Util.null2String(request.getParameter("messageId"));
    this.logger.info("messageCenter--->setMsgRead--->messageId:{}", messageId);
    String typeId = Util.null2String(request.getParameter("typeId"));
    this.logger.info("messageCenter--->setMsgRead--->typeId:{}", typeId);
    String userId = Util.null2String(request.getParameter("userId"));
    this.logger.info("messageCenter--->setMsgRead--->userId:{}", userId);
    List<String> accountList = Util_Account.getAccountList(userId);
    this.logger.info("messageCenter--->setMsgRead--->accountList:{}", accountList);
    long l = System.currentTimeMillis();
    this.logger.error("--setMsgRead--bs--" + l);
    this.logger.error("--setMsgRead--start--" + System.currentTimeMillis());
    Thread thread = new Thread((Runnable)new Object(this, typeId, userId, accountList, messageId, l));
    thread.start();
    this.logger.error("--setMsgRead--end--" + System.currentTimeMillis());
    boolean state = true;
    if (state) {
      resultObject.put("success", Boolean.valueOf(true));
      resultObject.put("code", Integer.valueOf(200));
      resultObject.put("message", "成功");
      return resultObject.toJSONString();
    } 
    resultObject.put("message", "消息状态更新失败");
    return resultObject.toJSONString();
  }
  
  private JSONArray getMsgInfo(String msgId, String type, String userId, String columnName) {
    this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>msgId:{}", msgId);
    this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>type:{}", type);
    this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>userId:{}", userId);
    String queryInfoSql = "";
    String queryReadSql = "";
    JSONArray msgList = new JSONArray();
    RecordSet queryInfoSet = new RecordSet();
    String sysCode = getSyscode();
    SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    if ("0".equals(type)) {
      queryInfoSql = "select messageId,title,detailtitle,messagegrouptype,userid,linkurl,linkmobileurl,creater,state,createdate,createtime from ecology_message_info where " + columnName + " IN(" + msgId + ") and userid = '" + userId + "'";
    } else if ("1".equals(type)) {
      queryInfoSql = "select messageId,title,detailtitle,messagegrouptype,userid,linkurl,linkmobileurl,creater,state,createdate,createtime from ecology_message_info where " + columnName + " = '" + msgId + "' and userid = '" + userId + "'";
    } else {
      queryInfoSql = "select messageId,title,detailtitle,messagegrouptype,userid,linkurl,linkmobileurl,creater,state,createdate,createtime from ecology_message_info where messagegrouptype = '" + msgId + "' and state != '2' and userid = '" + userId + "'";
    } 
    this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>queryInfoSql:{}", queryInfoSql);
    queryInfoSet.executeQuery(queryInfoSql, new Object[0]);
    this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>count:{}", Integer.valueOf(queryInfoSet.getCounts()));
    while (queryInfoSet.next()) {
      JSONObject msgObject = new JSONObject();
      String creatorId = queryInfoSet.getString("creater");
      String targetId = queryInfoSet.getString("userid");
      User creator = new User(Integer.valueOf(creatorId).intValue());
      User targetUser = new User(Integer.valueOf(targetId).intValue());
      msgObject.put("msgId", queryInfoSet.getString("messageId"));
      msgObject.put("msgTitle", queryInfoSet.getString("title"));
      msgObject.put("messageDesc", queryInfoSet.getString("detailtitle").replace("${}", ""));
      msgObject.put("startTellerNo", creator.getLoginid());
      msgObject.put("startTellerName", creator.getLastname());
      msgObject.put("pcTargetUrl", "/e10PortalHomePage/api/weavernorth/portal/messageCenter/getProcessPage?url=" + Base64Encoder.encode(queryInfoSet.getString("linkurl").replaceAll("^(http|https)://(\\d{1,3}\\.)+(\\d{1,3}):\\d{1,4}", "")) + "&syscode=" + sysCode);
      msgObject.put("appTargetUrl", "/e10PortalHomePage/api/weavernorth/portal/messageCenter/getProcessPage?url=" + Base64Encoder.encode(queryInfoSet.getString("linkmobileurl").replaceAll("^(http|https)://(\\d{1,3}\\.)+(\\d{1,3}):\\d{1,4}", "")) + "&syscode=" + sysCode);
      msgObject.put("msgRecvTellerNo", targetUser.getLoginid());
      msgObject.put("msgRecvTellerName", targetUser.getLastname());
      msgObject.put("msgSta", "1");
      try {
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>createdate:{}", queryInfoSet.getString("createdate"));
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>createtime:{}", queryInfoSet.getString("createtime"));
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>format:{}", String.valueOf(format.parse(queryInfoSet.getString("createdate") + " " + queryInfoSet.getString("createtime")).getTime()));
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>getTime:{}", String.valueOf((new Date()).getTime()));
        msgObject.put("msgRecvTime", String.valueOf(format.parse(queryInfoSet.getString("createdate") + " " + queryInfoSet.getString("createtime")).getTime()));
        msgObject.put("msgReadTime", String.valueOf((new Date()).getTime()));
      } catch (Exception e) {
        e.printStackTrace();
      } 
      msgList.add(msgObject);
    } 
    RecordSet queryReadSet = new RecordSet();
    if ("0".equals(type)) {
      queryReadSql = "select messageId,title,detailtitle,messagegrouptype,userid,linkurl,linkmobileurl,creater,state,createdate,createtime from ecology_message_info_read where " + columnName + " IN(" + msgId + ") and userid = '" + userId + "'";
    } else if ("1".equals(type)) {
      queryReadSql = "select messageId,title,detailtitle,messagegrouptype,userid,linkurl,linkmobileurl,creater,state,createdate,createtime from ecology_message_info_read where " + columnName + " = '" + msgId + "' and userid = '" + userId + "'";
    } else {
      queryReadSql = "select messageId,title,detailtitle,messagegrouptype,userid,linkurl,linkmobileurl,creater,state,createdate,createtime from ecology_message_info_read where messagegrouptype = '" + msgId + "' and state != '2' and userid = '" + userId + "'";
    } 
    this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>queryReadSql:{}", queryReadSql);
    queryReadSet.executeQuery(queryReadSql, new Object[0]);
    this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>count:{}", Integer.valueOf(queryReadSet.getCounts()));
    while (queryReadSet.next()) {
      JSONObject msgObject = new JSONObject();
      String creatorId = queryReadSet.getString("creater");
      String targetId = queryReadSet.getString("userid");
      User creator = new User(Integer.valueOf(creatorId).intValue());
      User targetUser = new User(Integer.valueOf(targetId).intValue());
      msgObject.put("msgId", queryReadSet.getString("messageId"));
      msgObject.put("msgTitle", queryReadSet.getString("title"));
      msgObject.put("messageDesc", queryReadSet.getString("detailtitle").replace("${}", ""));
      msgObject.put("startTellerNo", creator.getLoginid());
      msgObject.put("startTellerName", creator.getLastname());
      msgObject.put("pcTargetUrl", "/e10PortalHomePage/api/weavernorth/portal/messageCenter/getProcessPage?url=" + Base64Encoder.encode(queryReadSet.getString("linkurl").replaceAll("^(http|https)://(\\d{1,3}\\.)+(\\d{1,3}):\\d{1,4}", "")) + "&syscode=" + sysCode);
      msgObject.put("appTargetUrl", "/e10PortalHomePage/api/weavernorth/portal/messageCenter/getProcessPage?url=" + Base64Encoder.encode(queryReadSet.getString("linkmobileurl").replaceAll("^(http|https)://(\\d{1,3}\\.)+(\\d{1,3}):\\d{1,4}", "")) + "&syscode=" + sysCode);
      msgObject.put("msgRecvTellerNo", targetUser.getLoginid());
      msgObject.put("msgRecvTellerName", targetUser.getLastname());
      msgObject.put("msgSta", "1");
      try {
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>createdate:{}", queryReadSet.getString("createdate"));
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>createtime:{}", queryReadSet.getString("createtime"));
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>format:{}", String.valueOf(format.parse(queryReadSet.getString("createdate") + " " + queryReadSet.getString("createtime")).getTime()));
        this.logger.info("pushReadMsg------->消息中心已读推送---->getMsgInfo------>getTime:{}", String.valueOf((new Date()).getTime()));
        msgObject.put("msgRecvTime", String.valueOf(format.parse(queryReadSet.getString("createdate") + " " + queryReadSet.getString("createtime")).getTime()));
        msgObject.put("msgReadTime", String.valueOf((new Date()).getTime()));
      } catch (Exception e) {
        e.printStackTrace();
      } 
      msgList.add(msgObject);
    } 
    return msgList;
  }
  
  private String getSyscode() {
    RecordSet recordSet = new RecordSet();
    recordSet.executeQuery("select val from uf_param_config where classname='com.weavernorth.messageCenter.PushMessage' and methodname='onMessage' and param='name'", new Object[0]);
    if (recordSet.next()) {
      this.logger.info("PushMessagelxf---------->val:{}", recordSet.getString("val"));
      return recordSet.getString("val");
    } 
    return "oa1";
  }
}
